<?php

// 2018.04.13 bY Stefano.Deiuri@Elettra.Eu

define( 'ROOT_PATH', '' ); // ex. /var/www/html/cws' );

$cws_config =array(
	'global' =>array(	
		'conf_name'		=>'', // ex. IPAC XY
		'conf_url'		=>'', // ex. https://ipac_xy.org/',
		'spms_url'		=>'', // ex. https://spms.fnal.gov/pls/ipac_xy',
		'root_url'		=>'', // ex. http://ipac_xy.org/cws',
		'spms_passphrase'	=>'', // no ex.
		'cws_timezone'		=>'', // ex. Canada/Pacific',
		
		'date_start'		=>'', // year-month-day ex. 2018-04-10
		'date_end'		=>'', // year-month-day

		'root_path'		=>ROOT_PATH,
		'data_path'		=>'{root_path}/data',
		'out_path'		=>'{root_path}/html',
		'tmp_path'		=>'{root_path}/tmp',
		
		
		'cron_enabled'		=>false,
		
		'wget_options'		=>'-q',
		
		'debug'			=>false,
		'colored_output'	=>false,
		'verbose'		=>2,

		'chart_type'		=>'LineChart', // LineChart or AreaChart
		'chart_width'		=>800,
		'chart_height'		=>300,
		
		// Colors
		'color_primary'		=>'#023a73',
		'color_secondary'	=>'#d73d06',
		'color_r' 		=>'#FF4136',
		'color_y' 		=>'#FFDC00',
		'color_g' 		=>'#2ECC40',
		'color_a' 		=>'#990099',
		'color_nofiles' 	=>'#555555',
		'color_files' 		=>'#7FDBFF',
		'color_removed' 	=>'#000000',
		'color_qaok'		=>'#0074D9',
		
		// Labels
		'label_files'		=>'Ready for processing',
		'label_a'		=>'Assigned to an Editor',
		'label_g'		=>'Paper successfully processed',
		'label_y'		=>'Please check your e-mail',
		'label_r'		=>'Please check your e-mail',
		'label_nofiles' 	=>'No valid files uploaded yet'
		),
	
	//-------------------------------------------------------------------------------------------------
	'data_bak' =>array(
		'name'			=>'Data Backup',
		'cron'			=>'*:59',
	),

	//-------------------------------------------------------------------------------------------------
	'spms_importer' =>array(
		'name'			=>'SPMS Importer',
		'cron'			=>'*:00',
		
		'wget'			=>true,
		'skip_sessions'	=>false,
		
		'tmp_path'		=>'{tmp_path}/spms',
		
		// out
		'abstracts'		=>'{app_data_path}/abstracts.json',
		'programme'		=>'{app_data_path}/programme.json',
		'posters'		=>'{app_data_path}/posters.json',
		'po'			=>'{app_data_path}/po.json'
		),
	//-------------------------------------------------------------------------------------------------
	'spms_stats_importer' =>array(
		'name'			=>'SPMS Statistics Importer',
		'cron'			=>'*:*',
		
		'edot_xml_url'		=>'{spms_url}/edot.xml',
		'editors_xml_url'	=>'{spms_url}/rpt_activity.xml',
		
		// in
		'in_po'			=>'{data_path}/po.json',

		// out
		'editors_xml'		=>'{tmp_path}/editors.xml',
		'editors'		=>'{data_path}/editors.json',
		'edot_xml'		=>'{tmp_path}/edot.xml',
		'edot'			=>'{data_path}/edots.json',
		'stats'			=>'{data_path}/stats.json',
		'stats_last'		=>'{data_path}/stats_last.json'
		),
		
	//-------------------------------------------------------------------------------------------------
	'make_colors_css' =>array(
		'name'				=>'Colors Style Sheet',
		'cron'				=>'*:05'
	),

	//-------------------------------------------------------------------------------------------------
	'make_chart_abstracts' =>array(
		'name'				=>'Abstracts Submission Chart',
		'cron'				=>'*:05',
		
		'xtract'			=>'abstractsubmissions',
		'y_title'			=>'Abstracts',
		'startdate'			=>false, // ex. Y-m-d '2017-1-1', m =(month -1) 1 = feb
		'showmaxvalue'		=>false,
		'skip_format_check'	=>false, // usefull for regstats
		
		// in
		'chart_js'			=>'chart.js',
		'chart_html'		=>'chart.html',

		// out
		'out_js'			=>'chart_abstracts.js',
		'out_html'			=>'chart_abstracts.html'
	),
		
	//-------------------------------------------------------------------------------------------------
	'make_chart_papers' =>array(
		'name'				=>'Papers Submission Chart',
		'cron'				=>'*:05',
		
		'xtract'			=>'filesuploaded,papercode',
		'y_title'			=>'Papers',
		'startdate'			=>false,
		'showmaxvalue'		=>false,
		'skip_format_check'	=>false, // usefull for regstats
		
		// in		
		'chart_js'			=>'chart.js',
		'chart_html'		=>'chart.html',
		
		// out
		'out_js'			=>'chart_papers.js',
		'out_html'			=>'chart_papers.html'
		),		
		
	//-------------------------------------------------------------------------------------------------
	'make_chart_registrants' =>array(
		'name'				=>'Registrants Chart',
		'cron'				=>'*:05',
		
		'xtract'			=>'regstats',
		'y_title'			=>'Registrants',
		'startdate'			=>false,
		'showmaxvalue'		=>false,
		'skip_format_check'	=>true, // usefull for regstats
		
		// in		
		'chart_js'			=>'chart.js',
		'chart_html'		=>'chart.html',

		// out
		'out_js'			=>'chart_registrants.js',
		'out_html'			=>'chart_registrants.html'
		),		
		
	//-------------------------------------------------------------------------------------------------
	'make_page_participants' =>array(
		'name'				=>'Participants Page',
		'cron'				=>'*:05',
		
		// chart
		'xtract'			=>'regstats',
		'y_title'			=>'Registrants',
		'startdate'			=>false,
		'showmaxvalue'		=>false,
		'skip_format_check'	=>true, // usefull for regstats

		// list
		'xtract2'			=>'attendees',
		'chart_var'			=>'Registrants',
		
		// in		
		'chart_js'			=>'chart.js',
		'template_html'		=>'template.html',
		'css'				=>'Participants.css',
		
		// out
		'out_js'			=>'chart_participants.js',
		'out_css'			=>'participants.css',		
		'out_html'			=>'participants.html'
		),
		
	//-------------------------------------------------------------------------------------------------
	'make_page_programme' =>array( 
		'name'			=>'Scientific Programme Page',
		'cron'			=>'*:05',
		
		'img_path'		=>'programme/images',
		'base_url'		=>'programme.php',
		'tab_w'			=>" width='750'",
		
		'default_page'	=>'html/programme.php',
		
		'tsz_adjust'	=>0,
	
		// in
		'abstracts'		=>'{app_data_path}/abstracts.json',
		'programme'		=>'{app_data_path}/programme.json',

		// out
		'out_path'		=>'{out_path}/programme',
		'ics'			=>'{app_out_path}/programme.ics'
		),
		
	//-------------------------------------------------------------------------------------------------
	'app_paper_status' =>array(
		'name'			=>'Paper Status App',

		'echo_mode'		=>'web',

		'data_path'		=>'{data_path}/{app}',
		'tmp_path'		=>'{tmp_path}/{app}',

		'default_page'		=>'{app}/index.php',
		
		'colors_css'		=>true,
		
		'label_removed'		=>'Removed',


		// in
		'in_template_html'	=>'template.html',
		'in_po'			=>'{data_path}/po.json',
		'in_edot'		=>'{data_path}/edots.json',

		// out
		'log'			=>'{app_data_path}/usage.log'
		),
		
	//-------------------------------------------------------------------------------------------------
	'app_poster_police' =>array(
		'name'			=>'Poster Police App',
		'dummy_mode'	=>false,
		'pp_manager'	=>0, // PosterPolice PersonID
		'password'		=>'',

		'verbose'		=>0,
		'echo_mode'		=>'web',
		
		'data_path'		=>'{data_path}/{app}',

		'default_page'	=>'{app}/index.php',
		
		// in
		'in_pp'			=>'{data_path}/posters.json',
		
		// out
		'sync_url'		=>'{spms_url}/xtract.posterpolicesetstatus'
		),
		
	//-------------------------------------------------------------------------------------------------
	'page_edots' =>array(
		'name'			=>'Paper Processing Status Page',

		'echo_mode'		=>'web',
		
		'default_page'	=>'{app}/index.php',
		
		'colors_css'	=>true,		

		// in
		'in_edot'		=>'{data_path}/edots.json'
		),	
		
	//-------------------------------------------------------------------------------------------------
	'page_po_status' =>array(
		'name'			=>'Proceeding Office Status Page',

		'echo_mode'		=>'web',

		'default_page'		=>'{app}/index.html',

		'colors_css'		=>true,		
		
		'diff_tz'		=>-9,


		'label_g'		=>'GREEN DOT (successfully processed)',
		'label_y'		=>'YELLOW DOT (wait author approval)',
		'label_r'		=>'RED DOT (unsuccessfully processed)',
		
		// in
		'in_editors'		=>'{data_path}/editors.json',
		'in_edot'		=>'{data_path}/edots.json',
		'in_stats'		=>'{data_path}/stats.json'
		),
		
	//-------------------------------------------------------------------------------------------------
	'page_barcode' =>array(
		'name'			=>'BarCode Page',
		
		'echo_mode'		=>'web',
		
		'apk'			=>'JACoW_BarCode.apk',
		
		'data_path'		=>'{data_path}/{app}',
		'data_url'		=>'{root_url}/data/{app}', 

		'default_page'		=>'{app}/index.php',

		// in
		'template_html'		=>'template.html',
		'po'			=>'{data_path}/po.json',
		
		// out
		'log'			=>'{app_data_path}/usage.log'		
		)		
	);

	
//----------------------------------------------------------------------------
function require_lib( $_name, $_version ) {
 $fname =ROOT_PATH .'/libs/' .$_name .'-' .$_version .'.lib.php';
 
 if (!file_exists($fname)) {
	echo "\n\nERROR: unable to load lib $_name-$_version\n\nPlease check the ROOT_PATH!\n\n";
 }
 
 require_once( $fname );
}
	
?>
